package XWCH;

import java.io.IOException;

/**
 *
 * @author kchantola
 */
public class NationRegion {
    private int nationid;
    private String nation;
    private String region;
    ReadingTable rt;
    
    NationRegion(String tableName, int id) throws IOException{//CS: customer/supplier
        rt = new ReadingTable();
        String line = rt.getLine(tableName, id);

        //nation
        nationid = Integer.parseInt(rt.getLinePart(line, "|", 4))+1;
        line = rt.getLine("data/nation.tbl", nationid);
        nation = rt.getLinePart(line, "|", 2);

        //region
        int regionid = Integer.parseInt(rt.getLinePart(line, "|", 3))+1;
        line = rt.getLine("data/region.tbl", regionid);
        region = rt.getLinePart(line, "|", 2);
    }
    
    NationRegion(int nid) throws IOException{//CS: customer/supplier
        String line = "";
        rt = new ReadingTable();

        //nation
        nationid = nid;
        line = rt.getLine("data/nation.tbl", nationid);
        nation = rt.getLinePart(line, "|", 2);

        //region
        int regionid = Integer.parseInt(rt.getLinePart(line, "|", 3))+1;
        line = rt.getLine("data/region.tbl", regionid);
        region = rt.getLinePart(line, "|", 2);
    }
    
    public String getNation(){
        return nation;
    }
    
    public String getRegion(){
        return region;
    }
    
    public int getNationid(){
        return nationid;
    }
    
}
