package XWCH;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.StringTokenizer;

/**
 *
 * @author kchantola
 */
public class ReadingTable {    
    
    public String getLine(String fileName, int lineNum) throws IOException{
        String line = "";
        
        BufferedReader in = new BufferedReader(new FileReader(fileName));
        int lineCounter = 0;
        while ((line = in.readLine()) != null) {
            lineCounter++;
            if(lineCounter==lineNum){
                break;
            }
        }
        in.close();
        return line;
    }
    
    public String getLinePart(String line, String delimeter, int partNumber){
        String part = "";
        if(line != null){
            StringTokenizer st = new StringTokenizer(line, delimeter);
            int partCounter = 0;
            while (st.hasMoreTokens()){
                part = st.nextToken();
                partCounter++;
                if(partCounter == partNumber){
                    break;
                }
            }
        }
        return part;
    }
    
    //count number of records in table 
	public int countLinedNumber(String fileName) throws FileNotFoundException, IOException
	{
            BufferedReader in = new BufferedReader(new FileReader(fileName));
            String line = null;

            int count = 0;
            while ((line = in.readLine()) != null)
            {
                count++;
            }
            in.close();
            return count;
	}
        
        
}
