
package XWCH;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import org.jdom2.Document;
import org.jdom2.Element;
import org.jdom2.JDOMException;
import org.jdom2.input.SAXBuilder;

/**
 *
 * @author kchantola
 */
public class ReadingTreePattern {
    //parsing data warehouse model
    public void parse(String fileName, String fact_name, ArrayList dimensions_name, ArrayList measures_name)
    {
        fact_name = "";
        dimensions_name = new ArrayList();
        measures_name = new ArrayList();      

        Document document = new Document();
        Element root;
        
        SAXBuilder sxb = new SAXBuilder();
        try
        {
            document = sxb.build(new File(fileName)); // "dw-model.xml"
        } catch (JDOMException | IOException e)
        {
            System.out.println(e);
        }
        
        root = document.getRootElement();
        //fact
        Element fact = root.getChild("fact");
        fact_name = fact.getAttributeValue("id");
        //dimensions
        getChildElements(fact, "dimension", dimensions_name);
        
        //measures
        getChildElements(fact, "measure", measures_name);
        
    }
    
    public void getChildElements(Element element, String eName, ArrayList aList){
        List eList = element.getChildren(eName);
        Iterator i = eList.iterator();
        while (i.hasNext())
        {
            Element currentElement = (Element) i.next();
            aList.add(currentElement.getAttributeValue("id"));
        }
    }
}
