package XWCH;


public class WritingNonStrictNationLevels
{
    private String nsText;
    private String[][] nonStrict;
    private String[] levelNames;
    private int added;
    WritingNonStrictNationLevels(String[][] nonStrict, String[] levelNames){
        nsText = "";
        this.nonStrict = nonStrict;
        this.levelNames = levelNames;
        added = 0;
    }
    
    public void writeForward(int j){//Check the elements from level 0 to n
        String val = ""; 
        int levelLength = levelNames.length;
        if(j>=0 && j<levelLength-1){
            val = checkValue(j);
            if(!(val.equals(""))){
                j++;
            }
            else{
                if(j == 1){
                    nsText = nsText + "</" + levelNames[0] + ">";
                }
                j--;
            }
            writeForward(j);
        }
        else if(j==levelLength-1){
            writeBackward(j);
        }
    }
    
    public void writeBackward(int j){//check the elements from n to 0
        String val = "";
        int levelLength = levelNames.length;
        if(j==levelLength-1){
            val = checkValue(j);
            if(!(val.equals(""))){
                nsText = nsText + "</" + levelNames[j] + ">";
                writeBackward(j);
            }
            else{
                j--;
                writeBackward(j);
            }
        }
        else if (j>=0 && j<levelLength - 1){
            nsText = nsText + "</" + levelNames[j] + ">";
            writeForward(j);
        }
    }
    
    public String checkValue(int j){//check for element to be added to nsText
        String val = "";
        int levelLength = nonStrict[0].length;
        if(j==0){
            for(int i=0; i<nonStrict.length; i++){
                if(!(nonStrict[i][j].equals(""))){
                    val = nonStrict[i][j];
                    nsText = nsText + "\n\t\t<" + levelNames[j] + " value=\'" + val + "\'>";
                    deleteDuplicate(val, j);
                    break;
                }
            }
        }
        else if (j>0 && j<levelLength){
            for(int i=0; i<nonStrict.length; i++){
                if(!(nonStrict[i][j].equals("")) && nonStrict[i][j-1].equals("")){
                    val = nonStrict[i][j];
                    nsText = nsText + "<" + levelNames[j] + " value=\'" + val + "\'>";
                    deleteDuplicate(val, j);
                    break;
                }
            }
        }
        return val;
    }
    
    public void deleteDuplicate(String val, int j){//delete element already added to nsText
        int levelLength = nonStrict[0].length;
        if(j==0){
            for(int i=0; i<nonStrict.length; i++){
                if(nonStrict[i][j].equals(val)){
                    nonStrict[i][j]= "";
                }
            }
        }
        else if (j>0 && j<levelLength){
            for(int i=0; i<nonStrict.length; i++){
                if(nonStrict[i][j].equals(val) && nonStrict[i][j-1].equals("")){
                    nonStrict[i][j]= "";
                }
            }
        }
    }
    
    public String getnsText(){
        return nsText;
    }
}