package XWCH;

import java.io.IOException;

/**
 *
 * @author kchantola
 */
public class DimensionLevels {
    ReadingTable rt;
    
    DimensionLevels(){
        rt = new ReadingTable();
    }
    public String getDimensionLevels(String dimName, int id) throws IOException{       
       String levelText = "";
       if(dimName.equals("part")){
           String line = rt.getLine("data/part.tbl", id);
           String category = rt.getLinePart(line, "|", 5);
           levelText = "<type3 value=\'" + rt.getLinePart(category, " ", 1) + "\'>"
                   + "<type2 value=\'" + rt.getLinePart(category, " ", 2) + "\'>"
                   + "<type3 value=\'" + rt.getLinePart(category, " ", 3) + "\'>"
                   + "</type3></type2></type3>";
           
       }
       else if(dimName.equals("customer") || dimName.equals("supplier")){
           String line = "";
           if(dimName.equals("customer")){
               line = rt.getLine("data/customer.tbl", id);
           }
           else{
               line = rt.getLine("data/supplier.tbl", id);
           }
           int nationid = Integer.parseInt(rt.getLinePart(line, "|", 4))+1;
           line = rt.getLine("data/nation.tbl", nationid);
           levelText = "<nation value=\'" + rt.getLinePart(line, "|", 2) + "\'>";
           int regionid = Integer.parseInt(rt.getLinePart(line, "|", 3))+1;
           line = rt.getLine("data/region.tbl", regionid);
           levelText = levelText 
                   + "<region value=\'" + rt.getLinePart(line, "|", 2) + "\'>"
                   + "</region></nation>";
       }
       return levelText;
   }
    
    public String getDateLevels(String date){
        String levelText = "<day value=\'" + rt.getLinePart(date, "/", 1) + "\'>"
                + "<month value=\'" + rt.getLinePart(date, "/", 2) + "\'>"
                + "<year value=\'" + rt.getLinePart(date, "/", 3) + "\'>"
                + "</year></month></day>" ;
        
        return levelText;
    }
}
